<template>
  <div class="d-flex flex-column flex-grow-1">
    <div class="d-flex align-center py-3">
      <div>
        <div class="display-1">{{ $t("menu.categories") }}</div>
        <v-breadcrumbs :items="breadcrumbs" class="pa-0 py-2"></v-breadcrumbs>
      </div>
    </div>
    <div v-if="loading" class="loading">
      <loading />
    </div>
    <div v-if="!loading">
      <v-container fluid class="filter">
        <v-row align="center">
          <v-col cols="3">
            <v-select
            rounded
              v-model="filter"
              :label="$t('menu.sections')"
              :items="
                getSections.map(({ nameAr, id }) => ({
                  text: nameAr,
                  value: id,
                }))
              "
              outlined
              @change="fetchCategorys({ filter })"
            ></v-select>
          </v-col>
          <v-col cols="9">

          </v-col>
          <v-col cols="7" md="8">
            <v-text-field
            rounded
              outlined
              :label="$t('common.SearchInAll')"
              v-model.trim="search"
              hide-details
              clearable
              prepend-inner-icon="mdi-magnify"
            ></v-text-field>
          </v-col>
          <v-col cols="2" md="2">
            <v-btn
              block
              rounded
              height="55"
              class="mygrad"
              dark
              @click="fetchCategorys({ search })"
            >
              {{ $t("common.Search") }}
            </v-btn>
          </v-col>
          <v-col cols="2" md="2">
            <v-btn
              block
              rounded
              height="55"
              class="mygrad"
              dark
              @click="
                search = '';
                filter = '';
                fetchCategorys({ search });
              "
            >
              {{ $t("common.showAll") }}
            </v-btn>
          </v-col>
        </v-row>
      </v-container>
      <v-data-table
        :headers="headers"
        :items="getCategoriesList"
        loading-text="جاري تحميل البيانات"
        no-data-text="لا يوجد بيانات"
        hide-default-footer
        disable-filtering
        disable-pagination
        disable-sort
        class="elevation-1"
      >
        <template v-slot:top>
          <v-toolbar flat class="d-flex justify-end">
            <v-dialog v-model="dialog" max-width="500px">
              <template v-slot:activator="{ on, attrs }">
                <v-btn

                  dark
                  class="my-2 mygrad"
                  v-bind="attrs"
                  v-on="on"
                >
                  {{ $t("Category.createCategory") }}
                </v-btn>
              </template>
              <v-card>
                <v-card-title class="mygrad white--text">
                  <span class="text-h5">{{ formTitle }}</span>
                </v-card-title>

                <v-card-text class="mt-2">
                  <v-container>
                    <v-row>
                      <v-col cols="6">
                        <v-text-field
                          outlined
                          v-model="NameEn"
                          :label="$t('common.nameInEnglish')"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6">
                        <v-text-field
                          outlined
                          v-model="NameAr"
                          :label="$t('common.nameInArabic')"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6">
                        <v-select
                          v-model="SectionID"
                          :label="$t('menu.sections')"
                          :items="
                            getSections.map(({ nameAr, id }) => ({
                              text: nameAr,
                              value: id,
                            }))
                          "
                          outlined
                        ></v-select>
                      </v-col>

                      <v-col cols="6">
                        <v-text-field
                          outlined
                          v-model="id"
                          :label="$t('common.id')"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6">
                        <v-text-field
                          outlined
                          v-model="DisplayOrder"
                          :label="$t('common.DisplayOrder')"
                          type="number"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card-text>
                <hr class="header-divider primary" />
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn
                    dark
                    class="my-2 px-3 py-3 mygrad"
                    @click="save()"
                  >
                    {{ $t("common.save") }}
                  </v-btn>

                  <v-btn
                    text

                    class="my-2 mx-2 px-3 py-3"
                    @click="close()"
                  >
                    {{ $t("common.cancel") }}
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar>
        </template>
        <template v-slot:item.isActive="{ item }">
          <v-switch
            v-if="item.isActive === false"
            inset
            color="#bf87a0"
            v-model="item.isActive"
            @change="unblockUser(item.id)"
          ></v-switch>

          <v-switch
            v-if="item.isActive === true"
            inset
            color="#bf87a0"
            v-model="item.isActive"
            @change="blockUser(item.id)"
          ></v-switch>
        </template>
        <template v-slot:item.actions="{ item }">
          <v-icon small class="mr-2" @click="editItem(item)">
            mdi-pencil
          </v-icon>
        </template>
        <template v-slot:item.delete="{ item }">
          <v-dialog transition="dialog-top-transition" max-width="600">
            <template v-slot:activator="{ on, attrs }">
              <v-btn color="error" icon v-bind="attrs" v-on="on">
                <v-icon>delete</v-icon>
              </v-btn>
            </template>
            <template v-slot:default="dialog">
              <v-card>
                <v-toolbar color="red" dark>{{
                  $t("Category.deleteCategory")
                }}</v-toolbar>
                <v-card-text>
                  <h4 class="my-3 red--text">
                    {{ $t("Category.AreYouSureYouWantToDeleteThisCategory") }}
                  </h4>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn
                    color="red"
                    dark
                    @click="deleteThisCategory(item.id), (dialog.value = false)"
                  >
                    {{ $t("common.delete") }}
                  </v-btn>
                  <v-btn text @click="dialog.value = false">{{
                    $t("common.cancel")
                  }}</v-btn>
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>
        </template>
      </v-data-table>

      <div class="text-center">
        <v-container>
          <v-row justify="center">
            <v-col cols="8">
              <v-container class="max-width">
                <v-pagination
                  v-model="page"
                  circle
                  total-visible="7"
                  class="my-4"
                  :length="getLastPage"
                  @input="handlingRoute($event)"
                ></v-pagination>
              </v-container>
            </v-col>
          </v-row>
        </v-container>
      </div>
    </div>
  </div>
</template>

<script>
import CopyLabel from "../../components/common/CopyLabel";
import loading from "../../components/common/loading";
import { mapGetters, mapActions, mapMutations } from "vuex";
export default {
  components: {
    CopyLabel,
    loading,
  },
  data() {
    return {
      search: "",
      filter: "",
      isLoading: false,
      loading: true,
      dialog: false,
      dialogDelete: false,
      page: this.getFilter,
      id: "",
      NameEn: "",
      NameAr: "",
      DisplayOrder: null,
      SectionID: null,
      breadcrumbs: [
        {
          text: this.$i18n.t("menu.categories"),
          disabled: false,
          href: "#",
        },
        {
          text: this.$i18n.t("menu.usersList"),
        },
      ],

      searchQuery: "",
      headers: [
        {
          text: this.$i18n.t("common.id"),
          value: "id",
        },
        {
          text: this.$i18n.t("common.nameInEnglish"),
          value: "nameEn",
        },
        {
          text: this.$i18n.t("common.nameInArabic"),
          value: "nameAr",
        },
        {
          text: this.$i18n.t("common.stutas"),
          value: "isActive",
        },
        {
          text: this.$i18n.t("common.edit"),
          value: "actions",
        },
        {
          text: this.$i18n.t("common.delete"),
          value: "delete",
        },
      ],
      editedIndex: -1,
    };
  },
  computed: {
    ...mapGetters("Category", [
      "getCategoriesList",
      "getFilter",
      "getLastPage",
      "getSections",
    ]),
    formTitle() {
      return this.editedIndex === -1
        ? this.$i18n.t("Category.createCategory")
        : this.$i18n.t("Category.updateCategory");
    },
  },

  methods: {
    ...mapActions("Category", [
      "fetchCategorys",
      "postCategory",
      "updateCategory",
      "changeCategoryStatus",
      "deleteCategory",
      "fetchSections",
    ]),
    ...mapMutations("Category", ["setFilter"]),
    handlingRoute(event) {
      if (this.$route.path != `?PageNumber=${event}`) {
        this.$router.push(`?PageNumber=${event}`);
      }
    },
    editItem(item) {
      this.editedIndex = 500;
      this.id = item.id;
      this.NameEn = item.nameEn;
      this.NameAr = item.nameAr;
      this.DisplayOrder = item.displayOrder;
      this.SectionID = item.sectionID;
      this.dialog = true;
    },
    close() {
      this.dialog = false;
      this.id = "";
      this.NameEn = "";
      this.NameAr = "";
      this.DisplayOrder = null;
      this.SectionID = null;
      this.$nextTick(() => {
        this.editedIndex = -1;
      });
    },
    save() {
      if (this.editedIndex > -1) {
        this.editCategory();
      } else {
        this.addCategory();
      }
      this.close();
    },
    addCategory() {
      this.postCategory({
        id: this.id,
        NameEn: this.NameEn,
        NameAr: this.NameAr,
        DisplayOrder: this.DisplayOrder,
        SectionID: this.SectionID,
      }).then(() => {
        this.id = "";
        this.NameEn = "";
        this.NameAr = "";
        this.DisplayOrder = null;
        this.SectionID = null;
        this.fetchCategorys();
      });
    },
    editCategory() {
      this.updateCategory({
        id: this.id,
        NameEn: this.NameEn,
        NameAr: this.NameAr,
        DisplayOrder: this.DisplayOrder,
        SectionID: this.SectionID,
      }).then(() => {
        this.id = "";
        this.NameEn = "";
        this.NameAr = "";
        this.DisplayOrder = null;
        this.SectionID = null;
        this.fetchCategorys();
      });
    },

    blockUser(id) {
      this.changeCategoryStatus({
        id: id,
        status: false,
      });
    },
    unblockUser(id) {
      this.changeCategoryStatus({
        id: id,
        status: true,
      });
    },
    deleteThisCategory(id) {
      this.deleteCategory(id).then(() => {
        this.fetchCategorys();
      });
    },
  },
  mounted() {
    this.fetchSections();
  },
  watch: {
    $route: {
      async handler(route) {
        if (!route.query.PageNumber) {
          await this.$router.replace({
            query: { ...route.query, PageNumber: 1 },
          });
          return;
        }
        this.setFilter({ ...route.query });
        this.$store
          .dispatch("Category/fetchCategorys", route.query)
          .then(() => {
            this.loading = false;
          });
      },
      deep: true,
      immediate: true,
    },
  },
};
</script>

<style lang="scss" scoped>
.slide-fade-enter-active {
  transition: all 0.3s ease;
}
.slide-fade-leave-active {
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1);
}
.slide-fade-enter,
.slide-fade-leave-to {
  transform: translateX(10px);
  opacity: 0;
}
.filter {
  background-color: #fff;
}
</style>
